(function() {
	$.fn.weixinAudio = function(options) {
		var $this = $(this);
		var defaultoptions = {
			autoplay:false,
			src:'',
		};
		function Plugin($context) {
			//dom
			this.$context = $context;
			this.$Audio = $context.children('#media');
			this.Audio = this.$Audio[0];
			this.$audio_area = $context.find('#audio_area');
			this.$audio_length = $context.find('#audio_length');
			this.$audio_progress = $context.find('#audio_progress');
			this.$audio_curent_time = $context.find('#curent_time');
			//属性
			this.currentState = 'pause';
			this.time = null;
			this.settings = $.extend(true, defaultoptions, options);
			//执行初始化
			this.init();
		}
		Plugin.prototype = {
			init: function() {
				var self = this;
				self.updateTotalTime();
				self.events();
				// 设置src
				if(self.settings.src !== ''){
					self.changeSrc(self.settings.src);
				}
				// 设置自动播放
				if(self.settings.autoplay){
					self.play();
				}
			},
			play: function() {
				var self = this;
				/*if (self.currentState === "play") {
					self.pause();
					return;
				}*/
				if (self.$audio_area.hasClass('playing')) {
					self.pause();
					return;
				}
	            $('.weixinAudio').each(function(index, el) {
	            	$(this).children('#media')[0].pause();
	            	$(this).children('#media')[0].currentState == "pause";
					$(this).children('#audio_area').removeClass('playing');
	            });
				self.Audio.play();
				clearInterval(self.timer);
				self.timer = setInterval(self.run.bind(self), 50);
				self.currentState = "play";
				self.$audio_area.addClass('playing');
			},
			pause: function() {
				var self = this;
				self.Audio.pause();
				self.currentState = "pause";
	            self.$context.find(".icon_audiodefault").css({"display":"block"});
	            self.$context.find(".icon_audioplaying").css({"display":"none"});
				clearInterval(self.timer);
				self.$audio_area.removeClass('playing');
			},
			stop:function(){

			},
			events: function() {
				var self = this;
				var updateTime;
				self.$audio_area.on('click', function() {
		            $(".icon_audiodefault").css({"display":"block"});
		            $(".icon_audioplaying").css({"display":"none"});
		            self.$context.find(".icon_audiodefault").css({"display":"none"});
		            self.$context.find(".icon_audioplaying").css({"display":"block"});
					self.play();
					if (!updateTime) {
						self.updateTotalTime();
						updateTime = true;
					}
				});
			},
			//正在播放
			run: function() {
				var self = this;
				self.animateProgressBarPosition();
				if (self.Audio.ended) {
					self.pause();
		            self.$context.find(".icon_audiodefault").css({"display":"block"});
		            self.$context.find(".icon_audioplaying").css({"display":"none"});
		            /*a++;
					console.log(a)*/
				}
			},
			//进度条
			animateProgressBarPosition: function() {
				var self = this,
					percentage = (self.Audio.currentTime * 100 / self.Audio.duration) + '%';
				if (percentage == "NaN%") {
					percentage = 0 + '%';
				}
				var styles = {
					"width": percentage
				};
				var curs=Math.floor(self.Audio.currentTime);
				var curm=Math.floor(self.Audio.currentTime/60);
				curs = curs % 60
				if(curs<10){
					curs=String(0)+String(curs);
				}
				self.$audio_progress.css(styles);
				this.$audio_curent_time.text(curm+":"+curs)
			},
			
			//获取时间秒
			getAudioSeconds: function(string) {
				var self = this,
					string = string % 60;
				string = self.addZero(Math.floor(string), 2);
				(string < 60) ? string = string: string = "00";
				return string;
			},
			//获取时间分
			getAudioMinutes: function(string) {
				var self = this,
					string = string / 60;
				string = self.addZero(Math.floor(string), 2);
				(string < 60) ? string = string: string = "00";
				return string;
			},
			//时间+0
			addZero: function(word, howManyZero) {
				var word = String(word);
				while (word.length < howManyZero) word = "0" + word;
				return word;
			},
			//更新总时间
			updateTotalTime: function() {
				var self = this,
					time = self.Audio.duration,
					minutes = self.getAudioMinutes(time),
					seconds = self.getAudioSeconds(time),
					audioTime = minutes + ":" + seconds;
				self.$audio_length.text(audioTime);
			},
			//改变音频源
			changeSrc:function(src,callback){
				var self = this;
				self.pause();
				self.Audio.src = src;
				self.play();
				// callback();
			},
		};
		var obj = {}
		// var instantiate = function() {
		// 	 new Plugin($(this));
		// }
		$this.each(function(index,element){
			obj['weixinAudio'+index] = new Plugin($(this));
		}); //多个执行返回对象

		return obj
	}
})(jQuery)
    var a=0;
$(window).load(function (){
	$('.weixinAudio').each(function(index, el) {
		var audioSrc = $(this).find('audio').attr('src');
		$(this).weixinAudio({
	        autoplay:true,
	        src:audioSrc,
	    });
	});
})
